;======================================================================                
;               z e r o - p a g e   v a r i a b l e s 
;---------------------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
CPIO_DATA       = $02           ;this zeropage memory location is used to parse the CPIO data

TMP_1 = $10           ;a temporary register
TMP_2 = $11           ;a temporary register
;ADDRESS         = $11           ;and $12        ;this is a location in the zero-page (normally used for basic, but we are not using basic, so it is safe)
;GRAPH_X_L       = $13
;GRAPH_X_H       = $14

BMP_ADDR        = $15           
;BMP_ADR+1      = $16
VIDEO_ADDR      = $17  
;VIDEO_ADDR     = $18
COLCNT          = $19
BITCNT          = $20
CNTR            = $21
CNTR2           = $22
CURSOR_X        = $23           ;buffer used for text printing routine
CURSOR_Y        = $24           ;buffer used for text printing routine
CURSOR_ADDR     = $25           ;and 25

COL_PRINT       = $27           ;holds the color of the charaters printed with the PRINT_CHAR routine
COLOR_ADDR      = $28           ;pointer to color memory
;COLOR_ADDR+1   = $29
STR_ADDR        = $2A           ;pointer to string
;STR_ADDR+1     = $2B           ;           

SCROLL_X        = $3C
SCR_TXT_PNTR    = $3D
;SCR_TXT_PNTR+1 = $3E
SCR_ADR_PNTR    = $3F
;SCR_ADR_PNTR+1 = $40

LIGHTGUN_RAW_X          = $41   ;the uncallibrated lightgun position
LIGHTGUN_X_OFFSET       = $42   ;the measured offset of the lightgun
LIGHTGUN_X              = $43   ;the callibrated lightgun position
LIGHTGUN_RAW_Y          = $44   ;the uncallibrated lightgun position
LIGHTGUN_Y_OFFSET       = $45   ;the measured offset of the lightgun
LIGHTGUN_Y              = $46   ;the callibrated lightgun position


CURSOR_X        = $FA   ;buffer used for text printing routine
CURSOR_Y        = $FB   ;buffer used for text printing routine
CHAR_ADDR       = $FC
;CHAR_ADDR+1    = $FD


;======================================================================                
;                          C O N S T A N T S
;======================================================================                
SCROLLSCREEN    = 1984         ;first location of the line we want to scroll our text in ($07C0 = first char of last line)

;default positions for the moles

DEFAULT_XM1 = 60
DEFAULT_YM1 = 52

DEFAULT_XM2 = 180
DEFAULT_YM2 = 92

DEFAULT_XM3 = 60
DEFAULT_YM3 = 132

DEFAULT_XM4 = 180
DEFAULT_YM4 = 172

DEFAULT_XM5 = 60
DEFAULT_YM5 = 212
             

;----------------------------------------------------------------------

;COLOR          = $0268         ;current characxter color
;GDCOL          = $0287         ;backgorund color under cursor
BORDER          = $D020         ;bordercolour
BACKGROUND      = $D021         ;background-0
BACKGROUND1     = $D022         ;background-1
BACKGROUND2     = $D023         ;background-2
BACKGROUND3     = $D024         ;background-3
DATAPORTB       = $DC01         ;Data Port B (keyboard, joystick, paddles),:gameport 1        


CHARSCREEN      = $0400         ;location of the character screen memory
COLORSCREEN     = $D800         ;location of the color screen memory (this value cannot be changed)



; BASIC routines
;-----------------------
PRINT          = $AB1E   ;PRINT = Prints a null terminated string to screen whose address is in A/Y  ;call example:         LDA #<_TEXT                ;define the text used LDY #>_TEXT                ;where text is the label to the corresponding text to be printed JSR PRINT                  ;the print routine is called

; KERNAL routines
;-----------------------
ACPTR   = $FFA5
CHKIN   = $FFC6
CHKOUT  = $FFC9
CHRIN   = $FFCF
CHROUT  = $FFD2
CIOUT   = $FFA8
CINT    = $FF81
CLALL   = $FFE7
CLOSE   = $FFC3
CLRCHN  = $FFCC
GETIN   = $FFE4
IOBASE  = $FFF3
IOINIT  = $FF84
LISTEN  = $FFB1
LOAD    = $FFD5
MEMBOT  = $FF9C
MEMTOP  = $FF99
OPEN    = $FFC0
PLOT    = $FFF0
RAMTAS  = $FF87
RDTIM   = $FFDE
READST  = $FFB7
RESTOR  = $FF8A
SAVE    = $FFD8
SCNKEY  = $FF9F
SCREEN  = $FFED
SECOND  = $FF93
SETLFS  = $FFBA
SETMSG  = $FF90
SETNAM  = $FFBD
SETTIM  = $FFDB
SETTMO  = $FFA2
STOP    = $FFE1
TALK    = $FFB4
TKSA    = $FF96
UDTIM   = $FFEA
UNLSN   = $FFAE
UNTLK   = $FFAB
VECTOR  = $FF8D




;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;                                             BASIC STARTING ROUTINE 
;      now the program will start after typing the command "RUN" within basic (just like a real program)
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;                                             BASIC STARTING ROUTINE 
;      now the program will start after typing the command "RUN" within basic (just like a real program)
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
; 10 SYS (2560)

*=$801

        BYTE    $0E, $08, $0A, $00, $9E, $20, $28,  $32, $35, $36, $30, $29, $00, $00, $00


;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;                                         RASTYER INTERRUPT HANDLER
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;Raster interrupt used for sprite multiplexing and SID player

IRQ             SEI                     ;prevent non maskable interrupt      
                INC $D019               ;"acknowledge" the interrupt by clearing the VIC's interrupt flag.

                ;time,counters and sound
                ;.......................                        
IRQ_00         ;INC BORDER              ;extremely usefull for debugging purposes
                JSR SOUNDFX_PLAY        ;call the Sound/FX playing routine
               ;DEC BORDER              ;extremely usefull for debugging purposes

                LDA #100
                STA $D012                       ;Next interrupt to occur at raster line no. ...
                CLI                             ;enable non maskable interrupt

              ;  JMP $EA31                      ;Jump to the beginning KERNAL's standard interrupt service routine.
IRQ_DONE        JMP $EA81                       ;Jump to the end part of KERNAL's standard interrupt service routine we do not need to jump to $EA31, because we allready did this earlier and we do not want to execute the kernal interrupt again because we allraedy did this for this frame.
                                                ;$EA81 restores A,X,Y before RTS

