
*=$6000

;===============================================================================
;                            I M A G E   D A T A
;...............................................................................

incbin "image.dat",0            ;skip the first 0 bytes


;===============================================================================
;switch to HI-res mode (for an image already located at $6000)
;
;Call example:  JSR SHOW_BITMAP
;...............................................................................

SHOW_BITMAP     LDA #1                  ;set background and border colour
                STA BORDER              ;poke x in 53280,x (bordercolour)
                STA BACKGROUND          ;poke x in 53281,x (background-0)

                LDA $D011               ;blank screen during initialisation
                AND #%11101111          ;
                STA $D011               ;
                LDA $DD02               ;set video bank selection for the VIC
                ORA #3                  ;
                STA $DD02               ;
                LDA $DD00               ;
                AND #%11111100          ;
                ORA #2                  ;ORA # 2 selects bank-1 ($4000-$7FFF)
                STA $DD00               ;
                LDA #%00001000          ;disable multicolor mode
                STA $D016               ;
                LDA #$18                ;xxxx1xxx means bitmap adress is bank+$2000
                STA $D018               ;xxxx0xxx means bitmap adress is bank+$0000
                LDA #%00111011          ;Bitmap Mode ON (we want to use monochrome HI-res mode) and enable screen
                STA $D011               ;

                ;we must set the background color otherwise the pixels will have the colors that are currently in memory, which isn't what we want!
SETBMPCOLORS    LDY #00                 ;this makes the loop 256 times
SETBMPCLR_LP    LDA #$10                ;this is the value which we store in all locations
                STA $4400,Y             ;first nibble is draw color, second nibble is background
                STA $4500,Y             ;value $50 means green lines on a black background
                STA $4600,Y             ;
                STA $46E8,Y             ;
                DEY                     ;
                BNE SETBMPCLR_LP        ;loop until done
                RTS                     ;

;===============================================================================
;switch to character mode and select custom charset
;
;Call example:  JSR NORMAL
;...............................................................................

SHOW_NORMAL     LDA #0                  ;set background and border colour
                STA BORDER              ;poke x in 53280,x (bordercolour)
                STA BACKGROUND          ;poke x in 53281,x (background-0)    

                LDA $D011               ;blank screen during initialisation
                AND #%11101111          ;
                STA $D011               ;
                LDA $DD02               ;set video bank selection for the VIC
                ORA #3                  ;
                STA $DD02               ;
                LDA $DD00               ;
                AND #%11111100          ;
                ORA #3                  ;ORA # 3 selects bank-0 ($0000-$3FFF)
                STA $DD00               ;
                LDA #%00001011          ;disable multicolor mode
                STA $D016               ;
                LDA #%00011011          ;Bitmap Mode OFF and enable screen
                STA $D011               ;
                LDA $D018               ;get current charset location settings
                AND #%11110001          ;mask out unrelated bits
                ORA #%00001110          ;set charset related bits to the preferred state
                STA $D018               ;set charset to new location ($3800-$3FFF)
                RTS


